addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin == "bluphoenix" then
		if player.mo.eflags & MFE_UNDERWATER then
			player.charability = CA_SWIM
		else
			player.charability = CA_NONE
		end
	end
end)


addHook("PlayerThink", function(player)
	if player.mo.skin ~= "bluphoenix" then
		return
	end
	
	if (player.cmd.buttons & BT_USE) and P_IsObjectOnGround(player.mo) and player.speed == 0 then
		player.height = 30*FRACUNIT
		player.mo.state = S_PLAY_GLIDE_LANDING
		player.pflags = $ | PF_FULLSTASIS
	else
		player.height = 48*FRACUNIT
	end
end)

local function functionname(player)
    if player.mo.skin ~= "bluphoenix" then
        return
    end
	
	if P_IsObjectOnGround(player.mo) and player.speed > 0 and player.spindelay == 0 then
		player.pflags = $1|PF_SPINNING
		player.mo.state = S_PLAY_ROLL
		S_StartSound(player.mo, sfx_spin)
		player.spindelay = $ + 1*TICRATE
	end
end

addHook("SpinSpecial", functionname)

addHook("AbilitySpecial", function(player)
    if player.mo.skin == "bluphoenix" then
        if player.abilityused < 2 and player.dualdelay == 0 and not (player.mo.eflags & MFE_UNDERWATER) then
            player.abilityused = $ + 1
            player.dualdelay = $ + TICRATE/3
            if player.jcurrentability == 0 then -- Let's internally call 0 a Thok.
				P_SetObjectMomZ(player.mo, 14*FRACUNIT)
				player.mo.state = S_PLAY_ROLL
				player.pflags = $|PF_THOKKED|PF_SPINNING
				S_StartSound(player.mo, sfx_s3k45)
				player.jcurrentability = 1
			elseif player.jcurrentability == 1 then
				if player.hyper and player.hyper.capable and player.powers[pw_super] then
					P_SetObjectMomZ(player.mo, 26*FRACUNIT)
					player.mo.state = S_PLAY_FALL
					player.pflags = $|PF_THOKKED|PF_SPINNING
					S_StartSound(player.mo, sfx_bkpoof)
					P_NukeEnemies(player.mo, player.mo, 3608*FRACUNIT)
					P_FlashPal(player, PAL_WHITE, 6)
					player.ghosttrail = 1
				else
					P_SetObjectMomZ(player.mo, 20*FRACUNIT)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_THOKKED|PF_SPINNING
					S_StartSound(player.mo, sfx_s3k40)
					player.mo.color = SKINCOLOR_BLUE -- Replace this with whatever color you want
					player.mo.colorized = true
					player.ghosttrail = 1
					S_StartSound(player.mo, sfx_s3k82)
				end
			end
        end
    end
end)		

addHook("PlayerThink", function(player)
	if player.mo.skin == "bluphoenix" then
		if leveltime % 2 and player.ghosttrail == 1 then
			local ghost = P_SpawnGhostMobj(player.mo)
			ghost.fuse = TICRATE/3
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.skin ~= "bluphoenix" then
		return
	end
	
	if player.mo.state == S_PLAY_MELEE and (player.mo.eflags & MFE_SPRUNG) or player.mo.state == S_PLAY_MELEE_FINISH and (player.mo.eflags & MFE_SPRUNG) or player.mo.state == S_PLAY_MELEE_LANDING and (player.mo.eflags & MFE_SPRUNG) then
		player.mo.momz = $*5/4
		player.mo.momx = $*5/4
		player.mo.momy = $*5/4
		S_StartSound(player.mo, sfx_sprong)
	end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin == "bluphoenix" then
        if player.dualdelay == nil then player.dualdelay = 0
        elseif player.dualdelay > 0 then player.dualdelay = $ - 1 end
        if P_IsObjectOnGround(player.mo) then
			player.abilityused = 0
			player.meleeused = 0
			player.jcurrentability = 0
			player.mo.color = player.skincolor
			player.mo.colorized = false
			player.ghosttrail = 0
		end
    end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin ~= "bluphoenix" then
        return
    end
    
    if (player.cmd.buttons & BT_CUSTOM1) and P_IsObjectOnGround(player.mo) and player.speed < 6 and player.spindelay == 0 then
        player.pflags = $ |PF_THOKKED|PF_SPINNING
        player.mo.state = S_PLAY_MELEE
		player.mo.tics = 2
		player.spindelay = TICRATE/2
		P_Thrust(player.mo, player.mo.angle, 3*FRACUNIT)
		P_SetObjectMomZ(player.mo, 2*FRACUNIT)
		S_StartSound(player.mo, sfx_s3k8b)
	elseif player.speed > 5 and (player.cmd.buttons & BT_CUSTOM1) and P_IsObjectOnGround(player.mo) and player.spindelay == 0 then
        player.mo.state = S_PLAY_MELEE
		P_SetObjectMomZ(player.mo, 3*FRACUNIT)
		player.pflags = $1|PF_SPINNING
		player.mo.tics = 2
		S_StartSound(player.mo, sfx_s3k8b)
		player.spindelay = 1*TICRATE
		P_Thrust(player.mo, player.mo.angle, 6*FRACUNIT)
	elseif player.meleeused < 3 and (player.cmd.buttons & BT_CUSTOM1) and not P_IsObjectOnGround(player.mo) and player.spindelay == 0 then
		player.mo.state = S_PLAY_MELEE
		P_SetObjectMomZ(player.mo, 2*FRACUNIT)
		player.pflags = $1|PF_SPINNING|PF_THOKKED
		player.mo.tics = 2
		player.meleeused = $ + 1
		S_StartSound(player.mo, sfx_s3k42)
		player.spindelay = 1*TICRATE
		P_Thrust(player.mo, player.mo.angle, 17*FRACUNIT)
		player.mo.color = player.skincolor
		player.mo.colorized = false
		player.ghosttrail = 0
	end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin == "bluphoenix" then
        if player.spindelay == nil then player.spindelay = 0
        elseif player.spindelay > 0 then player.spindelay = $ - 1 end
	end
end)

/*addHook("PlayerThink", function(player)
	if player.mo.skin == "phoenix" then
		if leveltime % 4 >= 2 then
			player.mo.color = SKINCOLOR_BLUE -- Replace this with whatever color you want
			player.mo.colorized = true
		else
			player.mo.color = player.skincolor
			player.mo.colorized = false
		end
	end
end)*/

addHook("PlayerThink", function(player)
    if player.mo.skin ~= "bluphoenix" then
        return
    end
	
	if P_IsObjectOnGround(player.mo) then
		if (player.cmd.buttons & BT_CUSTOM3) then
			player.mo.state = S_PLAY_FACEPLANT
			player.pflags = $ | PF_STASIS
		end
	end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin ~= "bluphoenix" then
        return
    end
	
	if P_IsObjectOnGround(player.mo) then
		if (player.cmd.buttons & BT_TOSSFLAG) then
			player.mo.state = S_PLAY_HEHASDRIP
		end
	end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin ~= "bluphoenix" then
        return
    end
	
	if player.mo.state == S_PLAY_HEHASDRIP then
		player.pflags = $ | PF_STASIS
	end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin ~= "bluphoenix" then
        return
    end
	
	if player.mo.state == S_PLAY_FACEPLANT then
		player.pflags = $ | PF_STASIS
	end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin ~= "bluphoenix" then
		return
	end
	
	if player.powers[pw_super] then
		player.mo.color = SKINCOLOR_SKY -- Replace this with whatever color you want
		player.mo.colorized = true
	end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin ~= "bluphoenix" then
		return
	end
	
	if player.hyper and player.hyper.capable and player.powers[pw_super] then
		player.normalspeed = 50*FRACUNIT
		player.jumpfactor = 2*FRACUNIT
		player.mo.colorized = true
	end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin ~= "bluphoenix" then
		return
	end
	
	if player.padashmodet == false then
		if player.dashmode == 3*TICRATE and P_IsObjectOnGround(player.mo) then
			S_StartSound(player.mo, sfx_s3k81)
			P_SpawnThokMobj(player)
			S_StartSound(player.mo, sfx_s3k46)
			P_Thrust(player.mo,player.mo.angle,5*FRACUNIT)
			local thokko = P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.scale * 20, MT_THOKKO)
			thokko.angle = player.mo.angle + ANGLE_90
			thokko.fuse = 7
			thokko.scale = 2*FRACUNIT/3
			thokko.destscale = 10*FRACUNIT
			thokko.colorized = true
			thokko.color = player.mo.color
			player.thokeffects = true
		else
			player.thokeffects = false
		end
	end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin == "bluphoenix" then
		if player.padashmodet == false then
			if player.dashmode > 3*TICRATE then
				P_SpawnThokMobj(player)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin == "bluphoenix" then
		if player.padashmodet == true then
			player.charflags = skins[player.mo.skin].flags
		else
			player.charflags = $ | SF_DASHMODE
			player.charflags = $ & ~SF_RUNONWATER
		end
	end
end)