local ScriptLoaded = false

addHook("ThinkFrame", function()
	if not(ScriptLoaded)
		and CBW_Battle
		then
		ScriptLoaded = true
		local B = CBW_Battle
		
		
		local CosmicBlast = function(mo,doaction)
			local player = mo.player
			player.actiontext = "six shooter blast"
			player.actionrings = 5
			player.action2text = nil
			player.action2rings = 0
			
			
			if not(B.CanDoAction(player))
				player.actionstate = 0 --Default action state
				return end
			if player.actionstate == 0
				if doaction == 1
					player.actionstate = 1
					player.actiontime = 0
					B.PayRings(player)
					S_StartSound(mo,sfx_s3k3c)
				end
			end
			
			
			if player.actionstate == 1
				player.actiontime = $+1
				
				P_InstaThrust(mo,mo.angle,0)
				P_SetObjectMomZ(mo,P_MobjFlip(mo)*mo.scale,0)
				player.pflags = ($|PF_SPINNING)&~PF_JUMPED
				mo.state = S_PLAY_ROLL
				P_SpawnThokMobj(player)
				
				
				if player.actiontime == 20 then
					player.actionstate = 2
					player.actiontime = 0
				end
			end
			
			
			if player.actionstate == 2
				player.actiontime = $+1
				if player.actiontime%3==0
					P_SPMAngle(mo,MT_FBOMB,mo.angle,0)
				end 
			
				P_SetObjectMomZ(mo,P_MobjFlip(mo)*mo.scale*2,0)
				P_InstaThrust(mo,mo.angle+ANGLE_180,mo.scale*6)
				B.ApplyCooldown(player,TICRATE*2)
				mo.state = S_PLAY_MELEE
				player.pflags = $&~(PF_SPINNING)
				player.drawangle = mo.angle
				S_StartSound(player.mo,sfx_s3k4e,player)
				
				if player.actiontime == 20
					player.actionstate = 0
				end
			end
		end
		
		
		local PriorityFunc = function(player)
			if player.actionstate == 1 then
				B.SetPriority(player,1,3,nil,1,3,"midair charge spin")
			end
		end
		
		
		local CollideFunc = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
			if not (plr[n1] and plr[n1].valid and plr[n1].playerstate == PST_LIVE)
				or not mo[n1].health
				or not mo[n1].state == S_PLAY_ROLL
				or pain[n1]
				return false
			end
			if (hurt != 1 and n1 == 1) or (hurt != -1 and n1 == 2) --Make sure the other player wasn't damaged
				S_StartSound(mo[n1], sfx_lose)
				return true
			end
		end
		

		CBW_Battle.SkinVars["phoenix"] = {
			flags = SKINVARS_GUARD,
			weight = 68,
			shields = 2,
			special = CosmicBlast,
			guard_frame = 1,
			func_priority_ext = PriorityFunc,
			func_exhaust = ExhaustFunc,
			func_collide = CollideFunc
		}
	end
end)